
int capval[4];

int sensorPin = A0;    // select the input pin for the potentiometer
int s = 0;  // variable to store the value coming from the sensor
float voltage = 0;
int flag[4] = {0};

void setup() {
  Serial.begin(9600);  
  for(int i = 6; i <= 9; i++) {
    pinMode(i, INPUT);
  }
}
 
void loop () {
  capval[0] = readCapacitivePin(2);
  capval[1] = readCapacitivePin(3);
  capval[2] = readCapacitivePin(4);
  capval[3] = readCapacitivePin(5);
  
//  Serial.print("pin 2:    ");
//  Serial.println(capval[0]);
//  Serial.print("pin 3:    ");
//  Serial.println(capval[1]);
//  Serial.print("pin 4:    ");
//  Serial.println(capval[2]);
//  Serial.print("pin 5:    ");
//  Serial.println(capval[3]);

  s = analogRead(sensorPin);
  voltage = s * (5.0 / 1023.0);
//  Serial.println(voltage);

  delay(500);
  
  for(int i = 1; i < 4; i++) {
    if (capval[i] == 17 && flag[i] == 0) { 
//      Serial.println("Trigger:  ");
      Serial.print(1);
      Serial.println(i);
      flag[i] = 1;
    } else if(capval[i] < 17 && flag[i] == 1) {
      Serial.print(0);
      Serial.println(i);
      flag[i] = 0;
    }
  }
  
  if ((capval[0] == 17 | voltage > 1) && flag[0] == 0) {
    Serial.print(1);
    Serial.println(0);
    flag[0] = 1;
  } else if((capval[0] < 17 && voltage < 1) && flag[0] == 1) {
    Serial.print(0);
    Serial.println(0);
    flag[0] = 0;
  }
}
 
uint8_t readCapacitivePin(int pinToMeasure) {
  // Variables used to translate from Arduino to AVR pin naming
  volatile uint8_t* port;
  volatile uint8_t* ddr;
  volatile uint8_t* pin;
  // Here we translate the input pin number from
  // Arduino pin number to the AVR PORT, PIN, DDR,
  // and which bit of those registers we care about.
  byte bitmask;
  port = portOutputRegister(digitalPinToPort(pinToMeasure));
  ddr = portModeRegister(digitalPinToPort(pinToMeasure));
  bitmask = digitalPinToBitMask(pinToMeasure);
  pin = portInputRegister(digitalPinToPort(pinToMeasure));
  // Discharge the pin first by setting it low and output
  *port &= ~(bitmask);
  *ddr |= bitmask;
  delay(1);
  // Make the pin an input with the internal pull-up on
  *ddr &= ~(bitmask);
  *port |= bitmask;
 
  // Now see how long the pin to get pulled up. This manual unrolling of the loop
  // decreases the number of hardware cycles between each read of the pin,
  // thus increasing sensitivity.
  uint8_t cycles = 17;
  if (*pin & bitmask) { cycles = 0;}
  else if (*pin & bitmask) { cycles = 1;}
  else if (*pin & bitmask) { cycles = 2;}
  else if (*pin & bitmask) { cycles = 3;}
  else if (*pin & bitmask) { cycles = 4;}
  else if (*pin & bitmask) { cycles = 5;}
  else if (*pin & bitmask) { cycles = 6;}
  else if (*pin & bitmask) { cycles = 7;}
  else if (*pin & bitmask) { cycles = 8;}
  else if (*pin & bitmask) { cycles = 9;}
  else if (*pin & bitmask) { cycles = 10;}
  else if (*pin & bitmask) { cycles = 11;}
  else if (*pin & bitmask) { cycles = 12;}
  else if (*pin & bitmask) { cycles = 13;}
  else if (*pin & bitmask) { cycles = 14;}
  else if (*pin & bitmask) { cycles = 15;}
  else if (*pin & bitmask) { cycles = 16;}
 
  // Discharge the pin again by setting it low and output
  // It's important to leave the pins low if you want to 
  // be able to touch more than 1 sensor at a time - if
  // the sensor is left pulled high, when you touch
  // two sensors, your body will transfer the charge between
  // sensors.
  *port &= ~(bitmask);
  *ddr |= bitmask;
 
  return cycles;
}
